
#include<iostream>
#include<cstdlib>
using namespace std;

int wochentag(int jahr, int monat, int tag)
{
	// 1. januar im jahr 0 war ein sonntag (unter der annahme, dass der kalender
	// immer korrekt weitergefuehrt wurde - was er bekanntermassen nicht wurde...)
	const int januar_1_jahr_0 = 6;
	int tage_bis_monat[] = {0,31,59,90,120,151,181,212,243,273,304,334};

	int res = januar_1_jahr_0
	        // berechne wochentag des 1.1. im jahr "jahr": jedes jahr ist
	        // der 1.1. einen wochentag weiter als im jahr davor - bzw wenn
	        // das jahr davor ein schaltjahr war, zwei wochentage weiter
	        + jahr
	        // schaltjahre seit jahr 0:
	        + (jahr-1)/4 - (jahr-1)/100 + (jahr-1)/400
	        // berechne wochentag des 1. vom monat "monat" im jahr "jahr"
	        + tage_bis_monat[monat-1]
	        // ab maerz 1 dazurechnen, falls "jahr" ein schaltjahr ist:
	        + (monat>2 && (!(jahr%4) && (jahr%100) || !(jahr%400)))
	        + (tag-1);
	// kleinsten positiven repraesentanten des restklassen-rings zurueckgeben
	return((res%7 >= 0)?(res%7):(res%7+7));
}

int main(int argc, char** argv)
{
	string wochentage_namen[] = {"Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag"};
	int jahr,monat,tag;

	if(argc > 1) jahr  = atoi(argv[1]); else { cout << " Jahr  > "; cin >> jahr;  }
	if(argc > 2) monat = atoi(argv[2]); else { cout << " Monat > "; cin >> monat; }
	if(argc > 3) tag   = atoi(argv[3]); else { cout << " Tag   > "; cin >> tag;   }
	if(monat < 1 || monat > 12)
		{ cerr << "Monat muss zwischen 1 und 12 liegen\n"; return(1); }
	int monatstage[]={31,28+(!(jahr%4) && (jahr%100) || !(jahr%400)),31,30,31,30,31,31,30,31,30,31};
	if(tag < 1 || tag > monatstage[monat-1])
		{ cerr << "Tag muss in diesem Monat zwischen 1 und " << monatstage[monat-1] << " liegen\n"; return(1);}

	cout << wochentage_namen[wochentag(jahr,monat,tag)]<<"\n";
	return(0);
}
